# Generated by detroit
# See https://github.com/bourbonut/detroit/tree/main/api_maker

from functools import partial
from operator import is_not

class curveCardinal:
    def __init__(self, content="curveCardinal"):
        self.content = content

    def __repr__(self):
        return self.content

    def __str__(self):
        return self.content

    def __call__(self, *args):
        arguments = ", ".join(map(repr, args))
        return f"{self}({arguments})"

    def tension(self, tension=None):
        """
        Tension:0.00
        Source · Returns a cardinal curve with the specified tension in the range [0, 1]. The
        tension determines the length of the tangents: a tension of one yields all zero
        tangents, equivalent to curveLinear; a tension of zero produces a uniform Catmull–Rom
        spline. For example:
        .. code:: javascript

            const line = d3.line().curve(d3.curveCardinal.tension(0.5));


        See more informations `here <https://d3js.org/d3-shape/curve#curveCardinal_tension>`_.
        """
        arguments = ", ".join(map(repr, filter(partial(is_not, None), (tension,))))
        return curveCardinal(content=f"{self.content}.tension({arguments})")


    def areaStart(self):
        """
        Indicates the start of a new area segment. Each area segment consists of exactly two
        line segments: the topline, followed by the baseline, with the baseline points in
        reverse order.
        Indicates the end of the current area segment.
        Indicates the start of a new line segment. Zero or more points will follow.
        Indicates the end of the current line segment.
        Indicates a new point in the current line segment with the given x- and y-values.

        See more informations `here <https://d3js.org/d3-shape/curve#curve_areaStart>`_.
        """
        return curveCardinal(content=f"{self.content}.areaStart()")


    def areaEnd(self):
        """
        Indicates the end of the current area segment.
        Indicates the start of a new line segment. Zero or more points will follow.
        Indicates the end of the current line segment.
        Indicates a new point in the current line segment with the given x- and y-values.

        See more informations `here <https://d3js.org/d3-shape/curve#curve_areaEnd>`_.
        """
        return curveCardinal(content=f"{self.content}.areaEnd()")


    def lineStart(self):
        """
        Indicates the start of a new line segment. Zero or more points will follow.
        Indicates the end of the current line segment.
        Indicates a new point in the current line segment with the given x- and y-values.

        See more informations `here <https://d3js.org/d3-shape/curve#curve_lineStart>`_.
        """
        return curveCardinal(content=f"{self.content}.lineStart()")


    def lineEnd(self):
        """
        Indicates the end of the current line segment.
        Indicates a new point in the current line segment with the given x- and y-values.

        See more informations `here <https://d3js.org/d3-shape/curve#curve_lineEnd>`_.
        """
        return curveCardinal(content=f"{self.content}.lineEnd()")


    def point(self, x=None, y=None):
        """
        Indicates a new point in the current line segment with the given x- and y-values.

        See more informations `here <https://d3js.org/d3-shape/curve#curve_point>`_.
        """
        arguments = ", ".join(map(repr, filter(partial(is_not, None), (x, y))))
        return curveCardinal(content=f"{self.content}.point({arguments})")

