# Generated by detroit
# See https://github.com/bourbonut/detroit/tree/main/api_maker

from functools import partial
from operator import is_not

class forceY:
    def __init__(self, content="forceY"):
        self.content = content

    def __repr__(self):
        return self.content

    def __str__(self):
        return self.content

    def __call__(self, *args):
        arguments = ", ".join(map(repr, args))
        return f"{self}({arguments})"

    def strength(self, strength=None):
        """
        Source · If strength is specified, sets the strength accessor to the specified number
        or function, re-evaluates the strength accessor for each node, and returns this force.
        The strength determines how much to increment the node’s y-velocity: (y - node.y) ×
        strength. For example, a value of 0.1 indicates that the node should move a tenth of
        the way from its current y-position to the target y-position with each application.
        Higher values moves nodes more quickly to the target position, often at the expense of
        other forces or constraints. A value outside the range [0,1] is not recommended.
        If strength is not specified, returns the current strength accessor, which defaults to:
        .. code:: javascript

            function strength() {
              return 0.1;
            }

        The strength accessor is invoked for each node in the simulation, being passed the node
        and its zero-based index. The resulting number is then stored internally, such that the
        strength of each node is only recomputed when the force is initialized or when this
        method is called with a new strength, and not on every application of the force.

        See more informations `here <https://d3js.org/d3-force/position#y_strength>`_.
        """
        arguments = ", ".join(map(repr, filter(partial(is_not, None), (strength,))))
        return forceY(content=f"{self.content}.strength({arguments})")


    def y(self, y=None):
        """
        Source · If y is specified, sets the y-coordinate accessor to the specified number or
        function, re-evaluates the y-accessor for each node, and returns this force. If y is
        not specified, returns the current y-accessor, which defaults to:
        .. code:: javascript

            function y() {
              return 0;
            }

        The y-accessor is invoked for each node in the simulation, being passed the node and
        its zero-based index. The resulting number is then stored internally, such that the
        target y coordinate of each node is only recomputed when the force is initialized or
        when this method is called with a new y, and not on every application of the force.

        See more informations `here <https://d3js.org/d3-force/position#y_y>`_.
        """
        arguments = ", ".join(map(repr, filter(partial(is_not, None), (y,))))
        return forceY(content=f"{self.content}.y({arguments})")

